﻿using System;
using System.Collections.Generic;
using System.Text;
using CLab.Auxiliary;

namespace CLab
{
    /// <summary>
    /// LayoutTypeBool represents a boolean type
    /// </summary>
    public class LayoutTypeBool : LayoutType
    {
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="typeName">Name of the type</param>
        /// <param name="domSize">Domain size</param>
        public LayoutTypeBool(String typeName, int domSize)
            : base(typeName, booleanVarNumber(domSize), domSize)
        {
        }

        public override string ToString()
        {
            return String.Format("<LayoutTypeBool> {0}", base.ToString());
        }

    }
}
