﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Casper
{
    /// <summary>
    /// Interface for an assigned variable
    /// </summary>
    public interface IConsistentVar
    {
        /// <summary>
        /// Variable ID
        /// </summary>
        int VarID { get; }

        /// <summary>
        /// The selected value of the variable
        /// </summary>
        int? SelectedValue { get; }
    }
}
