// Description:  5 queen problem
// Author:  CLab# Crew
// Date:  2006-01-25

type
  Queen [1 .. 5];

variable
  Queen q1;
  Queen q2;
  Queen q3;
  Queen q4;
  Queen q5;

rule
  (((q1 != q2) & (q1 != (q2 - 1))) & (q1 != (q2 + 1)));
  (((q1 != q3) & (q1 != (q3 - 2))) & (q1 != (q3 + 2)));
  (((q1 != q4) & (q1 != (q4 - 3))) & (q1 != (q4 + 3)));
  (((q1 != q5) & (q1 != (q5 - 4))) & (q1 != (q5 + 4)));
  (((q2 != q3) & (q2 != (q3 - 1))) & (q2 != (q3 + 1)));
  (((q2 != q4) & (q2 != (q4 - 2))) & (q2 != (q4 + 2)));
  (((q2 != q5) & (q2 != (q5 - 3))) & (q2 != (q5 + 3)));
  (((q3 != q4) & (q3 != (q4 - 1))) & (q3 != (q4 + 1)));
  (((q3 != q5) & (q3 != (q5 - 2))) & (q3 != (q5 + 2)));
  (((q4 != q5) & (q4 != (q5 - 1))) & (q4 != (q5 + 1)));
