﻿using System;
using System.Collections.Generic;
using System.Text;

using Casper;
using CLab.Data;

namespace CLab.CSP
{
    public class CSPVarInfo
    {

        private Casper.LookAheadVarDom casperVar;
        private CLab.Data.Variable cpVar;
        private CLab.Data.Type cpType;
        private List<int> vDomainIndexes;

        public CSPVarInfo(Casper.LookAheadVarDom casperVar, CLab.Data.Variable cpVar, CLab.Data.Type cpType, List<int> vDomainIndexes)
        {
            this.casperVar = casperVar;
            this.cpVar = cpVar;
            this.cpType = cpType;
            this.vDomainIndexes = vDomainIndexes;

        }

        public Casper.LookAheadVarDom CasperVar
        {
            get { return casperVar; }
        }

        public CLab.Data.Variable CpVar
        {
            get { return cpVar; }
        }

        public CLab.Data.Type CpType
        {
            get { return cpType; }
        }

        public List<int> VDomainIndexes
        {
            get { return vDomainIndexes; }
        }
    }
}
