﻿using System;
using System.Collections.Generic;
using System.Text;

namespace CLab.CSP
{

    /// <summary>
    /// The first try of a structure representing unary constraints. Very space consuming structure,
    /// and thus should be improved.
    /// </summary>
    public class Unary
    {
        private int varID;
        private Boolean[] validDomains;

        public Unary(int varID, int size)
        {
            this.varID = varID;
            validDomains = new Boolean[size];
        }

        public int VarID
        {
            get { return varID; }
            set { varID = value; }
        }

        public Boolean[] ValidDomains
        {
            get { return validDomains; }
            set { validDomains = value; }
        }

        public void addValidDomain(int value)
        {
            validDomains[value] = true;
        }

        public void removeValidDomain(int value)
        {
            validDomains[value] = false;
        }

        public Boolean validDomain(int value)
        {
            try
            {
                if (validDomains[value] == true) return true;
            }
            catch (Exception) { }
            return false;
        }

        public override string ToString()
        {
            return "not yet implemented!";
        }
    }
}
